**********************************************************
*  TEST.ASM                                              *
*  PROGRAM USED TO TEST EMULATOR                         *
*  PROGRAM HAS BEEN TESTED.  USED TO CONTROL THE X-Y     *
*  LOCATION OF A LASER.   THIS PROGRAM DISPLAYS A 'POOR' *
*  PICTURE OF A HEART.   MRW                             *
**********************************************************
***   ADDR      
***   4000 - 5FFF        6321 EMULATE PORT 1&2
***   6000 - 7FFF        6321 EMULATE PORT 3&4
***   8000 - 9FFF        8250 UART
***   A000 - A7FF        RAM  2K BLOCK 
***   C800 - CFFF        RAM  2K BLOCK TARGET/BREAK POINT
***   E000 - FFFF        SYSTEM ROM 
*  
* SYSTEM CONSTANTS
*
STRTPRG   EQU  $C800          START OF TARGET PROGRAM ROM     
TARGRAM   EQU  $A780          START OF TARGET RAM
ENDRAM    EQU  $A7FF          END OF TARGET RAM     
*
* 6321 CONSTANTS
*
PEREGA    EQU  $0             PERIPHERAL REG. A
DDRA      EQU  $0             DATA DIRECTION REG. A
CONTA     EQU  $1             CONTROL REG. A
PEREGB    EQU  $2             PERIPHERAL REG. B
DDRB      EQU  $2             DATA DIRECTION REG. B
CONTB     EQU  $3             CONTROL REG. B
A6321     EQU  $4000          BASE ADDRESS 
B6321     EQU  $6000          BASE ADDRESS 
*
*
* SYSTEM VARIABLES
*
          ORG  TARGRAM        START OF RAM
TEMP      RMB  1              
          ORG  STRTPRG
*         LDS  
*
* MAIN LINE PROGRAM BEGINS HERE.
*
MAIN      LDAB #$00           SELECT DDRA PORT 1
          STAB CONTA+A6321
          LDAA #$FF           SET PORT 1 TO ALL OUTPUTS
          STAA DDRA+A6321
          LDAA #$04           SELECT CONTROLA
          STAA CONTA+A6321         
          STAB CONTA+B6321    SELECT DDRA PORT 3
          LDAA #$FF           SET PORT 3 TO ALL OUTPUTS
          STAA DDRA+B6321
          LDAA #$04           SELECT CONTROLA
          STAA CONTA+B6321

PLOT      LDX  #TABLE
PLOTNXT   LDAA X              GET VERTICAL
          BEQ  PLOT           WAS THE LAST BYTE:REPLOT
          COMA
          SUBA #10
          STAA PEREGA+A6321   UPDATE PORT1
          INX                 POINT TO NEXT CHARACTER
          LDAA X              GET HORIZONTAL
          BEQ  PLOT           WAS THE LAST BYTE:REPLOT
          COMA
          SUBA #10
          STAA PEREGA+B6321   UPDATE PORT3
          INX                 POINT TO NEXT CHARACTER
          JSR  DELAY
          BRA  PLOTNXT        
*
* STALL 
*
DELAY     PSHX
          LDX  #$0500
DLY       DEX  
          BNE  DLY
          PULX
          RTS

*
TABLE     EQU  *
*
* HEART
*
          FCB  05,21          VET/HOZ
          FCB  07,20          VET/HOZ
          FCB  09,19          VET/HOZ
          FCB  11,18          VET/HOZ
          FCB  14,16          VET/HOZ
          FCB  17,15          VET/HOZ
          FCB  21,14          VET/HOZ
          FCB  22,14          VET/HOZ
          FCB  25,15          VET/HOZ
          FCB  26,16          VET/HOZ
          FCB  28,19          VET/HOZ
          FCB  29,22          VET/HOZ
          FCB  29,23          VET/HOZ
          FCB  27,25          VET/HOZ
          FCB  25,26          VET/HOZ
          FCB  27,27          VET/HOZ
          FCB  29,30          VET/HOZ
          FCB  29,33          VET/HOZ
          FCB  27,35          VET/HOZ
          FCB  24,36          VET/HOZ
          FCB  21,36          VET/HOZ
          FCB  19,35          VET/HOZ
          FCB  17,34          VET/HOZ
          FCB  16,33          VET/HOZ
          FCB  13,30          VET/HOZ
          FCB  11,28          VET/HOZ
          FCB  09,25          VET/HOZ
          FCB  05,21          VET/HOZ
*
* MW
*
          FCB  25,50          VET/HOZ
          FCB  35,50          VET/HOZ
          FCB  30,53          VET/HOZ
          FCB  25,55          VET/HOZ
          FCB  30,57          VET/HOZ
          FCB  35,60          VET/HOZ
          FCB  25,60          VET/HOZ
          FCB  25,62          VET/HOZ
          FCB  35,62          VET/HOZ
          FCB  25,62          VET/HOZ
          FCB  30,64          VET/HOZ
          FCB  35,67          VET/HOZ
          FCB  30,70          VET/HOZ
          FCB  25,72          VET/HOZ
          FCB  35,72          VET/HOZ
*
* +
*
          FCB  22,60          VET/HOZ
          FCB  19,60          VET/HOZ
          FCB  19,56          VET/HOZ
          FCB  19,60          VET/HOZ
          FCB  19,63          VET/HOZ
          FCB  19,60          VET/HOZ
          FCB  16,60          VET/HOZ
*
* SW
*
          FCB  15,60          VET/HOZ
          FCB  15,50          VET/HOZ
          FCB  10,50          VET/HOZ
          FCB  10,60          VET/HOZ
          FCB  05,60          VET/HOZ
          FCB  05,50          VET/HOZ
          FCB  05,60          VET/HOZ
          FCB  05,62          VET/HOZ
          FCB  15,62          VET/HOZ
          FCB  05,62          VET/HOZ
          FCB  10,64          VET/HOZ
          FCB  15,67          VET/HOZ
          FCB  10,70          VET/HOZ
          FCB  05,72          VET/HOZ
          FCB  15,72          VET/HOZ
          FCB  0              END OF TABLE
*    
* INVALID INTERRUPT REQUEST
*
INVALID_IRQ    RTI            EXIT
*
* INTERRUPT VECTOR TABLE 
* 
          ORG  $CFF0  
          FDB  INVALID_IRQ     SERIAL COMMUNICATION INTERFACE
          FDB  INVALID_IRQ     TIMER OVERFLOW
          FDB  INVALID_IRQ     OUTPUT COMPARE
          FDB  INVALID_IRQ     INPUT CAPTURE 
          FDB  INVALID_IRQ     IRQ1
          FDB  INVALID_IRQ     SWI 
          FDB  INVALID_IRQ     NMI 
          FDB  MAIN            RESET 
          END

